︠4ec67726-831c-44c2-8397-3567f5fd7449i︠
%html
<h3>Problem 1 (Dual Numbers)</h3>
<p>The square of a small number is very small indeed; e.g., squaring $0.0001$ we get $0.00000001$. Let $\epsilon$ be an idealized small quantity with the property that $\epsilon\neq 0$ and $\epsilon^2=0$. "Numbers" of the form $a+b\epsilon$ with $a$ and $b$ real are called <strong>dual numbers</strong>. (Compare with the complex numbers, which are of the form $a+bi$ with $i^2=-1$). Dual numbers obey the rules of ordinary algebra, subject to the condition that $\epsilon^2 = 0$; for example, $$ (a+b\epsilon) + (c+d\epsilon) = (a+c) + (b+d)\epsilon $$</p>
<p><strong>a.</strong> Make a class for calculating with dual numbers. A skeleton is provided below: where it says "pass" you fill in the appropriate definition. Show examples of how each of the overloaded operator works. (Optional: Provide a _latex_ function, if you know LaTeX.)</p>
<p><span> </span></p>
<pre>class DualNum(SageObject):</pre>
<pre>    
    def __init__(self, a, b=0):
        self.a = RR(a)
        self.b = RR(b)

    def _repr_(self):
        return "DualNum(%s,%s)" % (self.a, self.b)

    def __neg__(self):
        pass

    def __add__(self, other):
        pass

    def __sub__(self, other):
        pass
        
    def __mul__(self, other):
        pass

    def __pow__(self, n):
        pass
</pre>
<p>&nbsp;</p>

︡cd887ffc-4e3b-48e4-8946-8dc759654b5f︡{"html": "<h3>Problem 1 (Dual Numbers)</h3>\n<p>The square of a small number is very small indeed; e.g., squaring $0.0001$ we get $0.00000001$. Let $\\epsilon$ be an idealized small quantity with the property that $\\epsilon\\neq 0$ and $\\epsilon^2=0$. \"Numbers\" of the form $a+b\\epsilon$ with $a$ and $b$ real are called <strong>dual numbers</strong>. (Compare with the complex numbers, which are of the form $a+bi$ with $i^2=-1$). Dual numbers obey the rules of ordinary algebra, subject to the condition that $\\epsilon^2 = 0$; for example, $$ (a+b\\epsilon) + (c+d\\epsilon) = (a+c) + (b+d)\\epsilon $$</p>\n<p><strong>a.</strong> Make a class for calculating with dual numbers. A skeleton is provided below: where it says \"pass\" you fill in the appropriate definition. Show examples of how each of the overloaded operator works. (Optional: Provide a _latex_ function, if you know LaTeX.)</p>\n<p><span> </span></p>\n<pre>class DualNum(SageObject):</pre>\n<pre>    \n    def __init__(self, a, b=0):\n        self.a = RR(a)\n        self.b = RR(b)\n\n    def _repr_(self):\n        return \"DualNum(%s,%s)\" % (self.a, self.b)\n\n    def __neg__(self):\n        pass\n\n    def __add__(self, other):\n        pass\n\n    def __sub__(self, other):\n        pass\n        \n    def __mul__(self, other):\n        pass\n\n    def __pow__(self, n):\n        pass\n</pre>\n<p>&nbsp;</p>"}︡
︠a908e943-a856-4584-b5e9-31394d08121b︠
class DualNum(SageObject):
    
    def __init__(self, a, b=0):
        self.a = a
        self.b = b
    
    def _latex_(self):
        return str(self.a)+"+"+str(self.b)+"\\epsilon"
        
        #"\\frac{"+str(self.num)+"}{"+str(self.den)+"}"
    
    def _repr_(self):
        return "DualNum(%s,%s)" % (self.a, self.b)
        
    def __neg__(self):
        return DualNum(-1*self.a,-1*self.b)
        
    def __add__(self, other):
        if(other in RR):
            other=DualNum(other)
        return DualNum(self.a+other.a,self.b+other.b)
    
    def __radd__(self, other):
        if(other in RR):
            other=DualNum(other)
        return DualNum(self.a+other.a,self.b+other.b)
        
    def __sub__(self, other):
        if(other in RR):
            other=DualNum(other)
        return DualNum(self.a-other.a,self.b-other.b)
        
    def __rsub__(self, other):
        if(other in RR):
            other=DualNum(other)
        return DualNum(self.a-other.a,self.b-other.b)
    
    def __mul__(self, other):
        if(other in RR):
            other=DualNum(other)
        newalpha=self.a*other.a
        newbeta=self.a*other.b+self.b*other.a
        return DualNum(newalpha,newbeta)

    def __rmul__(self, other):
        if(other in RR):
            other=DualNum(other)
        newalpha=self.a*other.a
        newbeta=self.a*other.b+self.b*other.a
        return DualNum(newalpha,newbeta)
        
    def __div__(self, other):
        if(other in RR):
            other=DualNum(other)
        newalpha=self.a/other.a
        newbeta=(self.b*other.a-self.a*other.b)/power(other.a,2)
        return DualNum(newalpha,newbeta)
    
    def __rdiv__(self,other):
        return DualNum(other/self.a, other/self.b)
        
    def __invert__(self):
        return DualNum(1/self.a,-self.b/power(self.a,2))
        
    def __lt__(self,other):
        if(self.a < other.a):
            return True
        if(self.a == other.a):
            if(self.b<other.b):
                return True
        return false
        
    def __gt__(self,other):
        if(self.a > other.a):
            return True
        if(self.a == other.a):
            if(self.b>other.b):
                return True
        return false
        
    def __le__(self,other):
        if(self.a < other.a):
            return True
        if(self.a==other.a):
            if(self.b<=other.b):
                return True
        return false
        
    def __ge__(self,other):
        if(self.a > other.a):
            return True
        if(self.a==other.a):
            if(self.b>=other.b):
                return True
        return false
            
    def __eq__(self,other):
        if(self.a == other.a):
            if(self.b == other.b):
                return True
        return false

    def __pow__(self, n):
        if(n==0):
            return DualNum(1,0)
        raised=1
        for i in range(n):
            raised*=self
        return DualNum(raised.a,raised.b)
︡6379ecd3-2f25-4042-a553-b198b91daa2a︡︡
︠0fa0c02e-badb-4ba0-a52f-3a9f87b3f1fe︠
pretty_print(3/2)
︡1e2c1ab4-ea6f-43d5-9872-04605268ab10︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\frac{3}{2}</span>"}︡
︠c21c9db6-a9ea-43ab-9e93-6fbddc21f9f8︠
f=DualNum(-2,6)
g=DualNum(1,5)
print f
print g
︡6056417c-40ec-478e-9392-72649aaf9122︡{"stdout": "DualNum(-2,6)\nDualNum(1,5)"}︡
︠b5c6749d-0b91-4353-9daa-fa53f51887a4︠
pretty_print(f+g)
print(g+f)
︡2c1f94ce-f6bf-4fcc-98f7-00cc145cb4dc︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-1+11\\epsilon</span>"}︡{"stdout": "DualNum(-1,11)"}︡
︠1b6b7be3-e69b-4835-aa08-5baf48ecd606︠
f-g
︡938748af-d611-4dea-b4e4-249447e3b09c︡{"stdout": "DualNum(2.00000000000000,2.00000000000000)"}︡
︠3069c1fc-8756-4d74-8b09-be32126c7752︠
f*g
︡29226737-3a82-4823-9989-8f18cf93f33a︡{"stdout": "DualNum(-2,-4)"}︡
︠a6157567-7ba9-427a-aab3-d26da00678b7︠
f/g
︡9da5dd7c-1fbe-4ba9-a449-fce7ff1f88ef︡{"stdout": "DualNum(-2,16)"}︡
︠a5e8dfa5-5f8b-46bf-b27e-7407e1ff3a52︠
power(f,2)
︡680ad2fd-dbd4-4c57-8171-822abe8f3867︡{"stdout": "DualNum(4,-24)"}︡
︠e659b445-751b-4820-ae70-0f020cb5f9b3︠
~f
︡1664a8bc-3b3c-42c8-acae-4166a530d9ff︡{"stdout": "hall\u00f3\nDualNum(-1/2,-3/2)"}︡
︠7ab422ba-e652-4edd-82bd-b3a2bb7f9fc9︠
3/f
︡81134a3f-a61f-453a-bfec-8c690c1a8ded︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_12.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"My9m\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpOGaHgC/___code___.py\", line 3, in <module>\n    exec compile(ur'_sage_const_3 /f' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"element.pyx\", line 1491, in sage.structure.element.RingElement.__div__ (sage/structure/element.c:11901)\n  File \"coerce.pyx\", line 707, in sage.structure.coerce.CoercionModel_cache_maps.bin_op (sage/structure/coerce.c:6079)\n  File \"coerce.pyx\", line 1178, in sage.structure.coerce.CoercionModel_cache_maps.get_action (sage/structure/coerce.c:10901)\n  File \"coerce.pyx\", line 1344, in sage.structure.coerce.CoercionModel_cache_maps.discover_action (sage/structure/coerce.c:12577)\n  File \"ring.pyx\", line 2618, in sage.rings.ring.is_Ring (sage/rings/ring.c:13901)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/categories/category.py\", line 472, in __contains__\n    c = x.category()\nTypeError: descriptor 'category' of 'sage.structure.sage_object.SageObject' object needs an argument"}︡
︠32fadb2d-4275-4931-b26a-624b61cf14e1i︠
%html
<p><strong>b.</strong> Make sure that you can add, multiply and substract reals from a dual number correctly. (Simply amend the code above, but provide examples of usage in all cases here below.)</p>

︡25fec844-5fd9-4e34-ba4d-57d554957c73︡{"html": "<p><strong>b.</strong> Make sure that you can add, multiply and substract reals from a dual number correctly. (Simply amend the code above, but provide examples of usage in all cases here below.)</p>"}︡
︠9fcae6f8-8e78-4985-b15e-c4f4dffb7499︠
print f+2
print 2+f
︡3f04ceb9-c6bb-487e-aff5-b1a21ae0a88d︡{"stdout": "DualNum(5.00000000000000,4.00000000000000)\nDualNum(5.00000000000000,4.00000000000000)"}︡
︠35b9230a-15e9-4cb7-993d-7b854a414ddc︠
print f-2
print 2-f
︡3bf79423-acab-4ad9-b616-0b7e108eaa39︡{"stdout": "DualNum(1.00000000000000,4.00000000000000)\nDualNum(1.00000000000000,4.00000000000000)"}︡
︠9bfd0d7d-947e-4295-9007-c2993868dcb2︠
print f*3
print 3*f
︡c4bb3a19-5f17-4221-b205-b2949c01956e︡{"stdout": "DualNum(9.00000000000000,12.0000000000000)\nDualNum(9.00000000000000,12.0000000000000)"}︡
︠b02ec903-1a00-4de1-91dc-55e9b19821bfi︠
%html
<p><strong>c.</strong> Assume that $c\neq 0$. What dual number does $(a+b\epsilon)/(c+d\epsilon)$ evaluate to? Add the definitions of <tt>__div__</tt>&nbsp;and __invert__ to the class <tt>DualNum</tt> that reflects what you found.</p>

<p><strong>Answer:</strong></p>
<p>Division.</p>
<p>$$\frac{a+b \epsilon}{c+d \epsilon}=\frac{(a+b \epsilon)(c-d \epsilon)}{(c+d \epsilon)(c-d \epsilon)}=\frac{ac - ad \epsilon + bc \epsilon - bd \epsilon^2}{c^2-d^2\epsilon^2} = \frac{ac+\epsilon(bc - ad)}{c^2} =&nbsp; \frac{a}{c}+\frac{bc - ad}{c^2}\epsilon$$</p>

︡47824cc9-1309-4fb1-9db5-cf5ee482bbd4︡{"html": "<p><strong>c.</strong> Assume that $c\\neq 0$. What dual number does $(a+b\\epsilon)/(c+d\\epsilon)$ evaluate to? Add the definitions of <tt>__div__</tt>&nbsp;and __invert__ to the class <tt>DualNum</tt> that reflects what you found.</p>\n\n<p><strong>Answer:</strong></p>\n<p>Division.</p>\n<p>$$\\frac{a+b \\epsilon}{c+d \\epsilon}=\\frac{(a+b \\epsilon)(c-d \\epsilon)}{(c+d \\epsilon)(c-d \\epsilon)}=\\frac{ac - ad \\epsilon + bc \\epsilon - bd \\epsilon^2}{c^2-d^2\\epsilon^2} = \\frac{ac+\\epsilon(bc - ad)}{c^2} =&nbsp; \\frac{a}{c}+\\frac{bc - ad}{c^2}\\epsilon$$</p>"}︡
︠3bfa193a-d625-4015-857a-bde755bfc448︠
print f/g
print f/3
#print 3/f # works fine on sage.ru.is
︡2b0110db-129b-4079-9db5-2771f757e4be︡{"stdout": "DualNum(-2,16)\nDualNum(-2/3,2)\n"}︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_11.py\", line 9, in <module>\n    exec compile(ur'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"cHJpbnQgZi9nCnByaW50IGYvMwpwcmludCAzL2Y=\"),globals())+\"\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpmdcRnb/___code___.py\", line 5, in <module>\n    exec compile(ur'print _sage_const_3 /f' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"element.pyx\", line 1491, in sage.structure.element.RingElement.__div__ (sage/structure/element.c:11901)\n  File \"coerce.pyx\", line 707, in sage.structure.coerce.CoercionModel_cache_maps.bin_op (sage/structure/coerce.c:6079)\n  File \"coerce.pyx\", line 1178, in sage.structure.coerce.CoercionModel_cache_maps.get_action (sage/structure/coerce.c:10901)\n  File \"coerce.pyx\", line 1344, in sage.structure.coerce.CoercionModel_cache_maps.discover_action (sage/structure/coerce.c:12577)\n  File \"ring.pyx\", line 2618, in sage.rings.ring.is_Ring (sage/rings/ring.c:13901)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/categories/category.py\", line 472, in __contains__\n    c = x.category()\nTypeError: descriptor 'category' of 'sage.structure.sage_object.SageObject' object needs an argument"}︡
︠6d562a43-bdd0-40d3-a009-90e7cc1047bbi︠
%html
<p>Invert. We know that the inverse of $a+b\epsilon$ is $\frac{1}{a+b \epsilon}$ because $a+b\epsilon \cdot \frac{1}{a+b \epsilon}=1$. Let&acute;s simplify the inverse.</p>
<p>$$\frac{1}{a+b \epsilon}\frac{a-b \epsilon}{a-b \epsilon} = \frac{a-b\epsilon}{a^2-b^2\epsilon^2}=\frac{1}{a}-\frac{b}{a^2}\epsilon$$</p>

︡c9964e39-9ee2-44b6-850f-da2c708ba723︡{"html": "<p>Invert. We know that the inverse of $a+b\\epsilon$ is $\\frac{1}{a+b \\epsilon}$ because $a+b\\epsilon \\cdot \\frac{1}{a+b \\epsilon}=1$. Let&acute;s simplify the inverse.</p>\n<p>$$\\frac{1}{a+b \\epsilon}\\frac{a-b \\epsilon}{a-b \\epsilon} = \\frac{a-b\\epsilon}{a^2-b^2\\epsilon^2}=\\frac{1}{a}-\\frac{b}{a^2}\\epsilon$$</p>"}︡
︠b324cef1-1373-4097-8096-98b17b8bc947︠
~f
︡9563e353-9d9e-4105-af31-9d5d3e97199e︡{"stdout": "DualNum(0.333333333333333,0.444444444444444)"}︡
︠4f49b485-13f2-4cb7-a4df-060bbae308fbi︠
%html
<p><strong>d. </strong>Find a meaningful way of overloading the comparison operators &lt;,&lt;=,==, etc and implement it.</p>

︡8e8061bc-0569-4715-9aae-19d1bc2392ae︡{"html": "<p><strong>d. </strong>Find a meaningful way of overloading the comparison operators &lt;,&lt;=,==, etc and implement it.</p>"}︡
︠468aa445-5834-4fef-b38d-6260fdbf665e︠
print f<g
print g<f
print g<g
︡88789984-0f66-4900-8d56-f1d643eec41d︡{"stdout": "False\nTrue\nFalse"}︡
︠d6dd3559-1930-4857-8329-0ea4731e51e0︠
print f<=g
print g<=f
print g<=g
print g>g
print g>=g
︡62831d9d-b869-4b29-9729-649fc9e30070︡{"stdout": "True\nFalse\nTrue\nFalse\nTrue"}︡
︠91ea6b23-72a2-4541-988e-c4827aff90c5︠
print f == g
print f == f
︡8c745a06-df52-4769-87c8-4419a351ea30︡{"stdout": "False\nTrue"}︡
︠a17c7b59-8b9f-405e-b236-5f15fd010bcbi︠
%html
<p><strong>e.</strong> Solve the second degree equation $x^2+x+\epsilon=0$ in dual numbers.</p>
<p><strong>Answer:</strong></p>
<p>First let&acute;s insert an arbitrary dual number in for $x$.</p>
<p>$$(a+b\epsilon)^2+(a+b\epsilon)+\epsilon=0$$</p>
<p>$$a^2+2ab\epsilon+b^2\epsilon^2+a+b\epsilon+\epsilon=0$$</p>
<p>We know that $\epsilon^2=0$...</p>
<p>$$(a^2+a)+(2ab+b+1)\epsilon=0$$</p>
<p>Now we want our dual number to be equal to zero the real number has to be zero and the factor in front of $\epsilon$. Let&acute;s first find out the possible values of $a$.</p>
<p>$$a^2+a=0$$</p>
<p>$$a(a+1)=0$$</p>
<p>So we see that either $a=0$ or $a=-1$. Now let&acute;s find out the possible values of $b$ given these values of $a$. We have the equation:</p>
<p>$$2ab+b+1=0$$</p>
<p>We will first use $a=0$ and obtain.</p>
<p>$$b+1=0$$</p>
<p>$$b=-1$$.</p>
<p>So one of our dual numbers is $0-\epsilon$ or simply $-\epsilon$. Now we will use $a=-1$:</p>
<p>$$-2b+b+1=0$$</p>
<p>$$-b+1=0$$</p>
<p>$$b=1$$</p>
<p>There we have another solution which is $-1+\epsilon$. It&acute;s easy to verify the solutions, the first solution</p>
<p>$$-\epsilon^2-\epsilon+\epsilon=0$$</p>
<p>$$0+(-1+1)\epsilon=0$$</p>
<p>$$0=0$$</p>
<p>And the second solution</p>
<p>$$(-1+\epsilon)^2+(-1+\epsilon)+\epsilon=0$$</p>
<p>$$1-2\epsilon+\epsilon^2-1+\epsilon+\epsilon=0$$</p>
<p>$$(1+0-1)+(-2+1+1)\epsilon=0$$</p>
<p>$$0=0$$</p>

︡3e1c9a5a-4419-4955-bab6-ab3d4234eda7︡{"html": "<p><strong>e.</strong> Solve the second degree equation $x^2+x+\\epsilon=0$ in dual numbers.</p>\n<p><strong>Answer:</strong></p>\n<p>First let&acute;s insert an arbitrary dual number in for $x$.</p>\n<p>$$(a+b\\epsilon)^2+(a+b\\epsilon)+\\epsilon=0$$</p>\n<p>$$a^2+2ab\\epsilon+b^2\\epsilon^2+a+b\\epsilon+\\epsilon=0$$</p>\n<p>We know that $\\epsilon^2=0$...</p>\n<p>$$(a^2+a)+(2ab+b+1)\\epsilon=0$$</p>\n<p>Now we want our dual number to be equal to zero the real number has to be zero and the factor in front of $\\epsilon$. Let&acute;s first find out the possible values of $a$.</p>\n<p>$$a^2+a=0$$</p>\n<p>$$a(a+1)=0$$</p>\n<p>So we see that either $a=0$ or $a=-1$. Now let&acute;s find out the possible values of $b$ given these values of $a$. We have the equation:</p>\n<p>$$2ab+b+1=0$$</p>\n<p>We will first use $a=0$ and obtain.</p>\n<p>$$b+1=0$$</p>\n<p>$$b=-1$$.</p>\n<p>So one of our dual numbers is $0-\\epsilon$ or simply $-\\epsilon$. Now we will use $a=-1$:</p>\n<p>$$-2b+b+1=0$$</p>\n<p>$$-b+1=0$$</p>\n<p>$$b=1$$</p>\n<p>There we have another solution which is $-1+\\epsilon$. It&acute;s easy to verify the solutions, the first solution</p>\n<p>$$-\\epsilon^2-\\epsilon+\\epsilon=0$$</p>\n<p>$$0+(-1+1)\\epsilon=0$$</p>\n<p>$$0=0$$</p>\n<p>And the second solution</p>\n<p>$$(-1+\\epsilon)^2+(-1+\\epsilon)+\\epsilon=0$$</p>\n<p>$$1-2\\epsilon+\\epsilon^2-1+\\epsilon+\\epsilon=0$$</p>\n<p>$$(1+0-1)+(-2+1+1)\\epsilon=0$$</p>\n<p>$$0=0$$</p>"}︡
︠70637a59-4387-41a0-b608-88e8b053f53ci︠
%html
<p><strong>f.</strong> (Bonus) Write a function that solves the second degree  equation $Ax^2+Bx+C=0$ where $A,B,C$ are dual numbers. The function  needs to find or show all dual numbers $x$ that fulfil a given equation.</p>

︡bbaee3c9-1902-45f0-83ce-c64303c39d0b︡{"html": "<p><strong>f.</strong> (Bonus) Write a function that solves the second degree  equation $Ax^2+Bx+C=0$ where $A,B,C$ are dual numbers. The function  needs to find or show all dual numbers $x$ that fulfil a given equation.</p>"}︡
︠e21d116d-bbd5-4fa5-8526-3da4d47f8489i︠
%html
<h3>Problem 2. (Quaternions)</h3>
<p>The quaternions are a generalization of the complex numbers. They have the form $$a+bi+cj+dk$$ where $a,b,c,d$ are real numbers and $i,j,k$ fulfill the following equation:</p>
<p>$$i^2=j^2+k^2=ijk=-1.$$</p>
<p>Note that here the order matters in multiplication: $ij=k$ but $ji=-k.</p>
<p>You can read more on Quaterions on <a title="mathworld" href="http://mathworld.wolfram.com/Quaternion.html">Mathworld </a>and <a href="http://en.wikipedia.org/wiki/Quaternion">Wikipedia</a>.</p>
<p>Write a class for Quaternions and implement all the meaningful operations. Give good examples of how each operator is used.</p>

︡6d7d29b0-8e22-40d1-a759-50848b3794bc︡{"html": "<h3>Problem 2. (Quaternions)</h3>\n<p>The quaternions are a generalization of the complex numbers. They have the form $$a+bi+cj+dk$$ where $a,b,c,d$ are real numbers and $i,j,k$ fulfill the following equation:</p>\n<p>$$i^2=j^2+k^2=ijk=-1.$$</p>\n<p>Note that here the order matters in multiplication: $ij=k$ but $ji=-k.</p>\n<p>You can read more on Quaterions on <a title=\"mathworld\" href=\"http://mathworld.wolfram.com/Quaternion.html\">Mathworld </a>and <a href=\"http://en.wikipedia.org/wiki/Quaternion\">Wikipedia</a>.</p>\n<p>Write a class for Quaternions and implement all the meaningful operations. Give good examples of how each operator is used.</p>"}︡
︠9c333b5c-b1e7-4f84-95f3-d1c861e23cc0︠
def prstr(i):
    if(i<0):
        return str(i)
    else:
        return "+"+str(i)

class Quaternions(SageObject):
    
    def __init__(self, a=0, b=0,c=0,d=0):
        self.a = a
        self.b = b
        self.c = c
        self.d = d
                
    def _repr_(self):
        return "Quaternions(%s,%s,%s,%s)" % (self.a, self.b, self.c, self.d)
        
    def _latex_(self):
        return str(self.a)+prstr(self.b)+"i"+prstr(self.c)+"j"+prstr(self.d)+"k"
        
    def __neg__(self):
        return Quaternions(-self.a,-self.b,-self.c,-self.d)
        
    def __add__(self, other):
        if(other in RR):
            other=Quaternions(other)
        return Quaternions(self.a+other.a,self.b+other.b,self.c+other.c,self.d+other.d)
        
    def __radd__(self, other):
        if(other in RR):
            other=Quaternions(other)
        return Quaternions(self.a+other.a,self.b+other.b,self.c+other.c,self.d+other.d)
        
    def __sub__(self, other):
        if(other in RR):
            other=Quaternions(other)
        return Quaternions(self.a-other.a,self.b-other.b,self.c-other.c,self.d-other.d)
        
    def __rsub__(self, other):
        if(other in RR):
            other=Quaternions(other)
        return Quaternions(other.a-self.a,other.b-self.b,other.c-self.c,other.d-self.d)
            
    def __mul__(self, other):
        if(other in RR):
            other=Quaternions(other)
        a=self.a*other.a-self.b*other.b-self.c*other.c-self.d*other.d
        b=self.a*other.b+self.b*other.a+self.c*other.d-self.d*other.c
        c=self.a*other.c-self.b*other.d+self.c*other.a+self.d*other.b
        d=self.a*other.d+self.b*other.c-self.c*other.b+self.d*other.a
        return Quaternions(a,b,c,d)
    
    def __rmul__(self, other):
        if(other in RR):
            other=Quaternions(other)
        a=self.a*other.a-self.b*other.b-self.c*other.c-self.d*other.d
        b=self.a*other.b+self.b*other.a+self.d*other.c-self.c*other.d
        c=self.a*other.c-self.d*other.b+self.c*other.a+self.b*other.d
        d=self.a*other.d+self.c*other.b-self.b*other.c+self.d*other.a
        return Quaternions(a,b,c,d)
        
    def __div__(self,other):
        if(other in RR):
            other=Quaternions(other)
        conj_other=Quaternions(other.a,-other.b,-other.c,-other.d)
        numer=conj_other*self
        denom=other.a*other.a+other.b*other.b+other.c*other.c+other.d*other.d
        return Quaternions(numer.a/denom, numer.b/denom, numer.c/denom, numer.d/denom)
        
    def __rdiv__(self,other):
        if(other in RR):
            other=Quaternions(other)
        conj_self=Quaternions(self.a,-self.b,-self.c,-other.d)
        numer=conj_self*other
        denom=self.a*self.a+self.b*self.b+self.c*self.c+self.d*self.d
        return Quaternions(numer.a/denom, numer.b/denom, numer.c/denom, numer.d/denom)
    
    def __invert__(self):
        conj_self=Quaternions(self.a,-self.b,-self.c,-self.d)
        length=sqrt(self.a*self.a+self.b*self.b+self.c*self.c+self.d*self.d)
        return Quaternions(conj_self.a/(length*length),conj_self.b/(length*length),conj_self.c/(length*length),conj_self.d/(length*length))
        
    def __lt__(self,other):
        return "This operation doesn´t make sense."
        
    def __gt__(self,other):
        return "This operation doesn´t make sense."
        
    def __le__(self,other):
        return "This operation doesn´t make sense."
        
    def __ge__(self,other):
        return "This operation doesn´t make sense."                
    
    def __eq__(self,other):
        if(self.a == other.a):
            if(self.b == other.b):
                if(self.c == other.c):
                    if(self.d == other.d):
                        return True
        return false
    
    def __pow__(self, n):
        if(n==0):
            return Quaternions(1,0,0,0)
        raised=1
        for i in range(n):
            raised*=self
        return Quaternions(raised.a,raised.b,raised.c,raised.d)
︡404769c4-2200-4982-a9a8-67cea535f119︡︡
︠188d6afd-214b-4c53-bcdf-d0d3cba46d96︠
f=Quaternions(-2,5,-7,0)
h=Quaternions(-2,-5,7,0) # conjugate of f
g=Quaternions(1,2,3,-4)
pretty_print(f) # it does print 0k, maybe better if it was -2+5i-7j
pretty_print(g)
︡bf5b633b-f7df-40a0-9f8a-8a72ff27ea9e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-2+5i-7j+0k</span>"}︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1+2i+3j-4k</span>"}︡
︠3d9faeee-e5c8-4010-b760-588dd18bc86e︠
print f+g
print 3+g
print g+3
print 3-g
print g-3
print f-g
print f*g
︡5506d06e-42d6-4738-97fd-350bf5d3ff71︡{"stdout": "Quaternions(-1,7,-4,-4)\nQuaternions(4,2,3,-4)\nQuaternions(4,2,3,-4)\nQuaternions(2,-2,-3,4)\nQuaternions(-2,2,3,-4)\nQuaternions(-3,3,-10,4)\nQuaternions(9,29,7,37)"}︡
︠ab5dd18f-6288-4fc1-b39a-a69b8a4f90ac︠
print g*f
print 4*f
print f*4
print ~f*f
print f^3
print f/g
#print (f/5)*5  # works fine on sage.ru.is
#print (5/f)*f  # works fine on sage.ru.is
print f+h
print f==g
print f<g #I think it is important to overload all the comparison operators even though most of them do not make sense, otherwise we might be using other comparison operators and get some strange result
print f>g
print f>=g
print f==f
︡ba5b73e1-ef93-45f9-8cbc-cbe1cb763e42︡{"stdout": "Quaternions(9,-27,-33,-21)\nQuaternions(-8,20,-28,0)\nQuaternions(-8,20,-28,0)\nQuaternions(1,0,0,0)\nQuaternions(436,-310,434,0)\nQuaternions(-13/30,37/30,19/30,7/10)\nQuaternions(-4,0,0,0)\nFalse\nThis operation doesn\u00b4t make sense.\nThis operation doesn\u00b4t make sense.\nThis operation doesn\u00b4t make sense.\nTrue"}︡
︠8f5b6d9d-6c97-403f-8803-b7a64b9f20c1i︠
%html
<h3>Problem 3 (<a href="http://projecteuler.net/index.php?section=problems&id=79">Problem 79</a> 
on Project Euler).</h3>
<p>A common security method used for online banking is to ask the user for three random characters from a passcode. For example, if the passcode was 531278, they may asked for the 2nd, 3rd, and 5th characters; the expected reply would be: 317.
</p>
<p>The text file, <a href='http://projecteuler.net/project/keylog.txt'>keylog.txt</a>, contains fifty successful login attempts.
</p>
<p>Given that the three characters are always asked for in order, analyse the file so as to determine the shortest possible secret passcode of unknown length.
</p>

︡ce041f58-4734-4a6b-b43c-768802ac932f︡{"html": "<h3>Problem 3 (<a href=\"http://projecteuler.net/index.php?section=problems&id=79\">Problem 79</a> \r\non Project Euler).</h3>\r\n<p>A common security method used for online banking is to ask the user for three random characters from a passcode. For example, if the passcode was 531278, they may asked for the 2nd, 3rd, and 5th characters; the expected reply would be: 317.\r\n</p>\r\n<p>The text file, <a href='http://projecteuler.net/project/keylog.txt'>keylog.txt</a>, contains fifty successful login attempts.\r\n</p>\r\n<p>Given that the three characters are always asked for in order, analyse the file so as to determine the shortest possible secret passcode of unknown length.\r\n</p>"}︡
︠e41cc7b0-9e12-42db-bb17-272972169cdb︠
v=[[3,1,9],[6,8,0],[1,8,0],[6,9,0],[1,2,9],[6,2,0],[7,6,2],[6,8,9],[7,6,2],[3,1,8],[3,6,8],[7,1,0],[7,2,0],[7,1,0],[6,2,9],[1,6,8],[1,6,0],[6,8,9],[7,1,6],[7,3,1],[7,3,6],[7,2,9],[3,1,6],[7,2,9],[7,2,9],[7,1,0],[7,6,9],[2,9,0],[7,1,9],[6,8,0],[3,1,8],[3,8,9],[1,6,2],[2,8,9],[1,6,2],[7,1,8],[7,2,9],[3,1,9],[7,9,0],[6,8,0],[8,9,0],[3,6,2],[3,1,9],[7,6,0],[3,1,6],[7,2,9],[3,8,0],[3,1,9],[7,2,8],[7,1,6]]
︡c32793e2-09cf-478c-bcb8-df8d7f6f205b︡︡
︠3789ef3b-e70a-488f-9bac-07c816f17ff6︠
# The algorithm is pretty straight forward.
# It goes through all the samples, finds some number that does not have any number to the
# left of it, then it goes through all the samples and deletes those that have the number
# to the left. Repeat until no items left in v.

def find_code(v):
    code=[]
    while(any_items(v)):
        for i in range(len(v)):
            if(len(v[i])>0):
                if(leftmost(v[i][0],v)):
                    code.append(v[i][0])
                    del_left(v[i][0],v)
                    break
    return code

#finds an item that does not have anything on its left side
def leftmost(k,v):
    for i in range(len(v)):
        if(len(v[i])>0):
            if(v[i][0]!=k):
                for j in range(1,len(v[i])):
                    if(v[i][j]==k):
                        return false
    return True

# deletes the leftmost item in v[i] if it is k
def del_left(k,v):
    for i in range(len(v)):
        if(len(v[i])>0):
            if(v[i][0]==k):
                del(v[i][0])
                
def any_items(v): #checks if there are any items in v
    for i in range(len(v)):
        if(len(v[i])>0):
            return True
    return false
︡68e8c285-c321-4f6d-86ec-72322ef1d0a1︡︡
︠5e7bc361-01d1-4941-b396-d81411d29dad︠
find_code(v)
︡3f851fc4-bb7c-47f1-a8e2-859f0d78498f︡{"stdout": "[7, 3, 1, 6, 2, 8, 9, 0]"}︡
︠473eb353-a136-4386-a6ea-128e87255536i︠
%html
<h3>Problem 4 (<a href="http://projecteuler.net/index.php?section=problems&amp;id=71">Problem 71</a> of project Euler)</h3>
<div>
<p>Consider the fraction, <em>n/d</em>, where <em>n</em> and <em>d</em> are positive integers. If <em>n</em><img style="vertical-align: middle;" src="http://projecteuler.net/images/symbol_lt.gif" border="0" alt="&lt;" width="10" height="10" /><em>d</em> and HCF(<em>n,d</em>)=1, it is called a reduced proper fraction.</p>
<p>If we list the set of reduced proper fractions for <em>d</em> <img style="vertical-align: middle;" src="http://projecteuler.net/images/symbol_le.gif" border="0" alt="&le;" width="10" height="12" /> 8 in ascending order of size, we get:</p>
<p style="text-align: center; font-size: 8pt;">1/8, 1/7, 1/6, 1/5, 1/4, 2/7, 1/3, 3/8, <strong>2/5</strong>, 3/7, 1/2, 4/7, 3/5, 5/8, 2/3, 5/7, 3/4, 4/5, 5/6, 6/7, 7/8</p>
<p>It can be seen that 2/5 is the fraction immediately to the left of 3/7.</p>
<p>By listing the set of reduced proper fractions for <em>d</em> <img style="vertical-align: middle;" src="http://projecteuler.net/images/symbol_le.gif" border="0" alt="&le;" width="10" height="12" /> 1,000,000 in ascending order of size, find the numerator of the fraction immediately to the left of 3/7.</p>
</div>

<p><strong>Answer:</strong></p>
<p>The function loops through all denominators from $1$ to $n$ and checks just the numerator that gives us the value that is to the left of $\frac{3}{7}$. The only thing that really needs explanation is how we obtain the numerator. Well we know that our number has to be</p>
<p>$$\frac{n}{d}&lt;\frac{3}{7}$$</p>
<p>$$n &lt; \frac{3}{7}\cdot d$$</p>
<p>We want the numerator to be less than $\frac{3}{7}$ so we take the floor of the right side:</p>
<p>$$n&lt; \lfloor \frac{3}{7} \cdot d\rfloor$$</p>
<p>Then we can be sure that we have the numerator of the fraction that is next to the left from $\frac{3}{7}$ given the denominator $d$.</p>

︡dfa704c5-ec31-4849-9f70-c983693048f4︡{"html": "<h3>Problem 4 (<a href=\"http://projecteuler.net/index.php?section=problems&amp;id=71\">Problem 71</a> of project Euler)</h3>\n<div>\n<p>Consider the fraction, <em>n/d</em>, where <em>n</em> and <em>d</em> are positive integers. If <em>n</em><img style=\"vertical-align: middle;\" src=\"http://projecteuler.net/images/symbol_lt.gif\" border=\"0\" alt=\"&lt;\" width=\"10\" height=\"10\" /><em>d</em> and HCF(<em>n,d</em>)=1, it is called a reduced proper fraction.</p>\n<p>If we list the set of reduced proper fractions for <em>d</em> <img style=\"vertical-align: middle;\" src=\"http://projecteuler.net/images/symbol_le.gif\" border=\"0\" alt=\"&le;\" width=\"10\" height=\"12\" /> 8 in ascending order of size, we get:</p>\n<p style=\"text-align: center; font-size: 8pt;\">1/8, 1/7, 1/6, 1/5, 1/4, 2/7, 1/3, 3/8, <strong>2/5</strong>, 3/7, 1/2, 4/7, 3/5, 5/8, 2/3, 5/7, 3/4, 4/5, 5/6, 6/7, 7/8</p>\n<p>It can be seen that 2/5 is the fraction immediately to the left of 3/7.</p>\n<p>By listing the set of reduced proper fractions for <em>d</em> <img style=\"vertical-align: middle;\" src=\"http://projecteuler.net/images/symbol_le.gif\" border=\"0\" alt=\"&le;\" width=\"10\" height=\"12\" /> 1,000,000 in ascending order of size, find the numerator of the fraction immediately to the left of 3/7.</p>\n</div>\n\n<p><strong>Answer:</strong></p>\n<p>The function loops through all denominators from $1$ to $n$ and checks just the numerator that gives us the value that is to the left of $\\frac{3}{7}$. The only thing that really needs explanation is how we obtain the numerator. Well we know that our number has to be</p>\n<p>$$\\frac{n}{d}&lt;\\frac{3}{7}$$</p>\n<p>$$n &lt; \\frac{3}{7}\\cdot d$$</p>\n<p>We want the numerator to be less than $\\frac{3}{7}$ so we take the floor of the right side:</p>\n<p>$$n&lt; \\lfloor \\frac{3}{7} \\cdot d\\rfloor$$</p>\n<p>Then we can be sure that we have the numerator of the fraction that is next to the left from $\\frac{3}{7}$ given the denominator $d$.</p>"}︡
︠06d653eb-d4bc-4aa7-9a5f-7ca31d7e250e︠
def proper(n):
    prox=1
    num=0
    den=0
    for d in [1..n]:
        n = floor( (3/7) * d )
        curr_prox=3/7-n/d
        if(curr_prox > 0):
            if(curr_prox<prox):
                prox=curr_prox
                num=n
                den=d
    return num/den
︡530365cf-031b-43e9-ab43-2cd710de6517︡︡
︠2fd21ae0-7feb-41de-a014-05334470fb3fi︠
%html
<p>As we can see below the numerator we are looking for is $428570$.</p>

︡e100ad0f-924f-428d-93bf-0be234964bdf︡{"html": "<p>As we can see below the numerator we are looking for is $428570$.</p>"}︡
︠e4c09051-30d5-49cd-8c2a-513618fd21b1︠
time proper(1000000)
︡ed680def-83b3-499b-aebb-9b7e56914daf︡{"stdout": "428570/999997\nTime: CPU 8.42 s, Wall: 8.42 s"}︡
